uniform vec4 ambient_color;
uniform bool[128] light_state;
uniform vec2[128] light_pos;
uniform vec4[128] light_colors;
uniform float[128] light_radius;
uniform float light_count;
vec2 screenSz = vec2(love_ScreenSize);
vec4 v1 = vec4(1, 1, 1, 1);

float cdiff(vec4 A, vec4 B) //This function is really spliced together.
{
	float x = (A.x - B.x);
	float y = (A.y - B.y);
	float z = (A.z - B.z);
	float w = (A.w - B.w);
	float d = sqrt((x * x) + (y * y) + (z * z));
	return d / 3;
}

vec4 effect(vec4 color, Image texture, vec2 texture_coords, vec2 screen_coords)
{
	
	vec4 amb_base = ambient_color / 255;
	vec4 lColor = amb_base;
	vec4 texturecolor_pre = Texel(texture, texture_coords);
	
	for (int i = 0; i < int(light_count); i++) {
		bool state = light_state[i];
		if (state == true) {
			vec2 lightP = light_pos[i];
			vec4 lightC = light_colors[i];
			float r = light_radius[i];
			float dist = distance(lightP, screen_coords);
			if (dist <= r) {
				float percentColor = 1.0 - (dist / r);
				vec4 clr = (lightC / 255) * percentColor;
				lColor = lColor + clr;
			}
		}
	}
		
	float color_diff_scale = cdiff(lColor, texturecolor_pre);
	
	return (texturecolor_pre * color) - v1 + (lColor * (1 + color_diff_scale));
}